#include  <stdio.h>
#include  <time.h>
#include  <stdlib.h>

#include  <tthimage.h>
#include  <floatimg.h>

/* --------------------------------------------------------------- */
// new: Mon Sep 18 17:27:21 UTC 2023

int combine_trois(char *s1, char *s2, char *s3, char *dst, int k)
{
Image_Desc		*i1, *i2, *i3, *out;
int			x, y;
int			r1, g1, b1, r2, g2, b2, r3, g3, b3;
int			ro, go, bo;
int			foo;

/*
 *		NO MOLLYGUARD HERE ???
 */

// fprintf(stderr, "%s %s %s -> %s\n", s1, s2, s3, dst);

if (NULL==(i1 = Image_TGA_alloc_load(s1))) {
	perror(s1);
	return FULL_NUCKED;
	}

if (NULL==(i2 = Image_TGA_alloc_load(s2))) {
	perror(s2);
	return FULL_NUCKED;
	}

if (NULL==(i3 = Image_TGA_alloc_load(s3))) {
	perror(s3);
	return FULL_NUCKED;
	}

// fprintf(stderr, "%s: source images loaded\n", __func__);

if (NULL==(out = Image_clone(i1, 0))) {
	fprintf(stderr, "%s: err clone\n", __func__);
	return FULL_NUCKED;
	}

for (x=0; x<i1->width; x++) {
	for (y=0; y<i1->height; y++) {

		Image_getRGB  (i1,  x, y, &r1, &g1, &b1);
		Image_getRGB  (i2,  x, y, &r2, &g2, &b2);
		Image_getRGB  (i3,  x, y, &r3, &g3, &b3);
		// fprintf(stderr, "%4d %4d    %4d %4d %4d\n", x, y, r1, g1, b1);

		ro = ((r1 * r2) + (r3 * (255 - r2))) / 256;
		// fprintf(stderr, "%5d %5d %5d     %d\n", r1, r2, r3, ro);

		go = ((g1 * g2) + (g3 * (255 - g2))) / 256;
		bo = ((b1 * b2) + (b3 * (255 - b2))) / 256;

		Image_plotRGB (out, x, y,  ro,  go,  bo);

		}
	}

foo = Image_TGA_save(dst, out, 0);
if (foo) {
	fprintf(stderr, "ERR tga save %d\n", foo);
	exit(1);
	}

return FULL_NUCKED;
}
/* --------------------------------------------------------------- */


/* --------------------------------------------------------------- */
int main(int argc, char *argv[])
{
int		foo;

// Image_print_version(1);

if (5 != argc) {
	fprintf(stderr, "%s need 4 file names\n", argv[0]);
	return 1;
	}

foo = combine_trois(argv[1], argv[2],  argv[3], argv[4], 0);
fprintf(stderr, "combine trois -> %d\n", foo);

return 0;
}
/* --------------------------------------------------------------- */
